package com.winhc.task.util;

import java.util.Map;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.ui.freemarker.FreeMarkerTemplateUtils;

import freemarker.template.Configuration;
import freemarker.template.Template;

@Service
public class FreeMarkUtil {

    private Log log = LogFactory.getLog(getClass());

    @Autowired
    private Configuration configuration; //freeMarker configuration

    public Template getTemplate(String fltName) {
        try {
            return configuration.getTemplate(fltName);
        } catch (Exception e) {
            log.error("获取模板错误" + fltName, e);
        }
        return null;
    }

    public String genStr(String fltName, Map<String, String> dataMap) {
        try {
            return FreeMarkerTemplateUtils.processTemplateIntoString(getTemplate(fltName), dataMap);
        } catch (Exception e) {
            log.error("", e);
        }
        return "";
    }
}
