package com.winhc.task.util;

import com.alibaba.hologres.client.HoloClient;
import com.alibaba.hologres.client.HoloConfig;
import com.alibaba.hologres.client.exception.HoloClientException;
import com.alibaba.hologres.client.model.WriteMode;
import lombok.AllArgsConstructor;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.sql.Statement;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;

/**
 * @Author: π
 */
@Slf4j
public class HoloUtils {
    private static final String url;

    static {
        if (BaseUtils.isWindows()) {
            url = "jdbc:postgresql://hgprecn-cn-zvp2dvgsr005-cn-shanghai.hologres.aliyuncs.com:80/winhc_ng_rt";
        } else {
            url = "jdbc:postgresql://hgprecn-cn-zvp2dvgsr005-cn-shanghai-vpc.hologres.aliyuncs.com:80/winhc_ng_rt";
        }
    }

    private static final String username = "LTAI4G4n7pAW8tUbJVkkZQPD";
    private static final String password = "uNJOBskzcDqHq1TYG3m2rebR4c1009";

    public static HoloClient init() throws HoloClientException {
        HoloConfig config = new HoloConfig();
        config.setJdbcUrl(url);
        config.setUsername(username);
        config.setPassword(password);
        config.setFlushMaxWaitMs(60000 * 10L);
        config.setScanTimeoutSeconds(60 * 10);
        config.setBinlogReadTimeoutSeconds(60 * 10);
        config.setConnectionMaxIdleMs(60000 * 10L);
        config.setMetaCacheTTL(60000 * 10L);
        config.setWriteMode(WriteMode.INSERT_OR_REPLACE);//配置主键冲突时策略
        return new HoloClient(config);
    }

    @SneakyThrows
    public static void exexSql(HoloClient client, String pre_sql) {
        log.info("start exec holo sql : \n{}", pre_sql);
        client.sql(conn -> {
            Statement stat = conn.createStatement();
            return stat.execute(pre_sql);
        })
                .get();
                //.get(1000 * 60 * 30, TimeUnit.MILLISECONDS);
    }

    @SneakyThrows
    public static void exexSql2(HoloClient client, String pre_sql) {
        log.info("start exec holo sql : \n{}", pre_sql);
        client.sql(conn -> {
            Statement stat = conn.createStatement();
            return stat.execute(pre_sql);
        }).get(1000 * 60 * 30, TimeUnit.MILLISECONDS);
    }

}
