package com.winhc.task;

import com.alibaba.hologres.client.HoloClient;
import com.alibaba.hologres.client.exception.HoloClientException;
import com.winhc.task.util.FreeMarkUtil;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;

/**
 * @author π
 * @Description:
 * @date 2021/12/14 16:47
 */

@SpringBootTest
public class TestHolo {
    @Autowired
    HoloClient holoClient;

    @Autowired
    FreeMarkUtil freeMarkUtil;

    @Test
    public void start() throws HoloClientException, ExecutionException, InterruptedException, SQLException, TimeoutException {
        Map<String, String> m = new HashMap<>();
        m.put("targetTableName", "test_tmp_xf_sum_v9");
        m.put("tn", "company_zxr");
        m.put("keyno", "keyno");
        m.put("groupField", "deleted");
        m.put("condition", "in ('0','1')");
        String s = freeMarkUtil.genStr("agg_sample.ftl", m);

        System.out.println(s);

        Boolean r = holoClient.sql(conn -> {
            boolean res;
            Statement stat = conn.createStatement();
            res = stat.execute(s);
            System.out.println(res);
            return res;
        }).get(1000 * 60 * 30, TimeUnit.MILLISECONDS);

        holoClient.close();
        System.out.println(r);
        System.out.println("end");
    }
}
